#include <array>
#include <iostream>
#include <pqxx/pqxx>
#include <sstream>
#include <string>
#include <vector>

#include "interfaces/DatabaseConnection.h"
#include "interfaces/structs.h"

typedef std::vector<std::string> stringvec;

DatabaseConfiguration getConfiguration() {
  DatabaseCredentials credentials{};
  credentials.user = "kiqadmin";
  credentials.password = "kiqadmin";
  credentials.name = "kiq";

  DatabaseConfiguration configuration{};
  configuration.credentials = credentials;
  configuration.address = "127.0.0.1";
  configuration.port = "5432";

  return configuration;
}


stringvec ask_for_fields() {
  bool stop_asking = false;
  stringvec fields{};
  do {
    std::cout << "Field? Y/N" << std::endl;
    std::string response{};
    std::cin >> response;

    if (response == "N" || response == "n") {
      stop_asking = true;
    }

    std::cout << "Field:" << std::endl;
    std::string field{};
    std::cin >> field;
    fields.push_back(field);
  } while (!stop_asking);
  return fields;
}

stringvec ask_for_values() {
  bool stop_asking = false;
  stringvec values{};
  int index = 1;
  do {
    std::cout << "Value? Y/N" << std::endl;
    std::string response{};
    std::getline(std::cin, response);

    if (response == "N" || response == "n") {
      stop_asking = true;
    }

    std::cout << index << std::endl;
    std::string value{};
    values.push_back((std::cin, value));
    index++;
  } while (!stop_asking);
  return values;
}

void performQuery(DatabaseConnection* connection) {
  DatabaseQuery query{};
  query.type = QueryType::SELECT;
  query.table = "test";
  QueryResult result = connection->query(query);

  for (auto row : result.values) {
    std::cout << row.second << std::endl;
  }

  DatabaseQuery insert_query{};
  insert_query.type = QueryType::INSERT;
  insert_query.table = "test";
  insert_query.fields = ask_for_fields();
  insert_query.values = ask_for_values();

  QueryResult insert_result = connection->query(insert_query);

  for (auto row : insert_result.values) {
    std::cout << row.second << std::endl;
  }
}

int main() {
  DatabaseConnection connection;
  connection.setConfig(getConfiguration());
  performQuery(&connection);

  return 0;
}
